<?xml version="1.0" encoding="utf-8"?>
<s:TitleWindow xmlns:fx="http://ns.adobe.com/mxml/2009"
			   xmlns:s="library://ns.adobe.com/flex/spark"
			   xmlns:ui="library://ns.adobe.com/flex/ui"
			   xmlns:mx="library://ns.adobe.com/flex/mx"
			   xmlns:components="br.com.dclick.components.*"
			   close="titlewindowCloseHandler(event)" 
			   creationComplete="creationCompleteHandler(event)" 
			   title="Pesquisa de Vitrine Loja Virtual" 
			   xmlns:visual="br.com.desenv.framework.component.visual.*"
			   maxWidth="1200" maxHeight="700" 
			    xmlns:autoComplete="br.com.desenv.framework.component.visual.autoComplete.*">
	
	<fx:Style source="../../../framework/util/estilo.css"/>
	
	
	<fx:Metadata>
		[Event(name="VitrineLvSelecionadoEvent")]
	</fx:Metadata>
	
	<fx:Script>
		<![CDATA[
			import br.net.upcode.framework.amf.AMFConnector;
			import br.net.upcode.framework.popup.UPCPopUpManager;
			import br.com.desenv.framework.util.DsvObjectUtil;
			import mx.core.FlexGlobals;;
			import mx.collections.ArrayCollection;
			import mx.rpc.events.FaultEvent;
			import mx.rpc.events.ResultEvent;
			import mx.rpc.remoting.mxml.RemoteObject;
			import mx.controls.Alert;
			
			import mx.events.CloseEvent;
			import mx.events.FlexEvent;
			import mx.managers.PopUpManager;
			
			
			import mx.controls.DateField;
			import mx.validators.Validator;
			import spark.events.TitleWindowBoundsEvent;
			
			
			import br.com.desenv.nepalign.vo.Page;
			import br.com.desenv.nepalign.vo.VitrineLv;

			import br.com.desenv.nepalign.vo.Marca;
			
			[Bindable]
			public var listaVitrineLv: ArrayCollection = new ArrayCollection();
			private var pageNumber: int = 1;
			private var totalRecords: int;
			private var pageSize: int = 15;
			private var lastPage: int = 1;
			
			[Bindable]
			private var listaMarcaPesquisa: ArrayCollection = new ArrayCollection();

			
			private var vitrineLvComponenteDetalhe: VitrineLvComponenteDetalhe;

			[Bindable]
			private var listaValidadorForm: Array = new Array();
			
// ---------------------------------- FUNCOES DE INICIALIZACAO E FINALIZACAO --------------------------------			
			
			
			
			private function validar(event: MouseEvent):Boolean 
			{
				var listaErroValidador:Array = Validator.validateAll(this.listaValidadorForm);
				var validado:Boolean = listaErroValidador.length == 0;
				return validado;
			}
			
			// Indica todas as validacoes necessarias
			private function carregarListaValidacao(): void
			{
				//implemente aqui outros validadores se necessario
			}

			private function montarObjetoFiltro(): VitrineLv
			{
				var vitrineLvFiltro: VitrineLv = new VitrineLv();
				
				vitrineLvFiltro.nome = ignTextInputNomePesquisa.text == ""?null:ignTextInputNomePesquisa.text;
				vitrineLvFiltro.dataInicio = ignTextInputDateDataInicioPesquisa.text == ""?null:DateField.stringToDate(ignTextInputDateDataInicioPesquisa.text, "DD/MM/YYYY");
				vitrineLvFiltro.dataFinal = ignTextInputDateDataFinalPesquisa.text == ""?null:DateField.stringToDate(ignTextInputDateDataFinalPesquisa.text, "DD/MM/YYYY");
				vitrineLvFiltro.ativo = ignComboBoxFixoAtivoPesquisa.selectedItem == null?null:ignComboBoxFixoAtivoPesquisa.selectedItem.codigo == ""?null:ignComboBoxFixoAtivoPesquisa.selectedItem.codigo; 
				vitrineLvFiltro.tipoExibicao = ignComboBoxFixoTipoExibicaoPesquisa.selectedItem == null?null:ignComboBoxFixoTipoExibicaoPesquisa.selectedItem.codigo == ""?null:ignComboBoxFixoTipoExibicaoPesquisa.selectedItem.codigo; 
				vitrineLvFiltro.marca = ignAutoCompleteMarca.itemSelecionado as Marca;
				return vitrineLvFiltro;
			}
			
			private function creationCompleteHandler( event: FlexEvent ): void {
				carregarListaValidacao();
				
				var remoteObjectVitrineLv: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("vitrineLvService", listarResultHandler);	
				
				var remoteObjectMarca: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("marcaService", listarMarcaPesquisaResultHandler);	
				remoteObjectMarca.getOperation("listar").send();
				
				var vitrineLvFiltro: VitrineLv = new VitrineLv();
				remoteObjectVitrineLv.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, 1, vitrineLvFiltro); 
			}
			
			protected function titlewindowCloseHandler(event:CloseEvent):void
			{
				UPCPopUpManager.instance.removePopUp(this);
			}
			
// ---------------------------------- RETORNO DA FUNCAO LISTAR  --------------------------------	
			
			private function listarResultHandler( event: ResultEvent ): void {
				var paginaVitrineLv: Page = event.result as Page;
				pageNumber = paginaVitrineLv.pageNumber;
				totalRecords = paginaVitrineLv.totalRecords;
				lastPage = paginaVitrineLv.lastPage();
				listaVitrineLv = paginaVitrineLv.recordList;
				labelPaginaAtual.text = "" + paginaVitrineLv.pageNumber;
				labelTotalRegistro.text = "Total de Registros " + paginaVitrineLv.totalRecords;
			}

// CARREGANDO COMBOS			
			private function listarMarcaPesquisaResultHandler( event: ResultEvent ): void 
			{
				listaMarcaPesquisa = event.result as ArrayCollection;
				listaMarcaPesquisa.addItemAt(null, 0);
			}

// ---------------------------------- ADICIONAR DINAMICAMENTE  --------------------------------				
	
			
			
// -------------FUNCAO DE FILTRAR  -------------------------------------------------------			

			private function buttonFiltrarClickHandler( event: MouseEvent ): void {
				if (validar(event))
				{
					var remoteObjectVitrineLv: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("vitrineLvService", listarResultHandler);	
					remoteObjectVitrineLv.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, 1, montarObjetoFiltro());
				}	 
			}
			
// -------------FUNCOES DE INSERIR E ATUALIZAR  -------------------------------------------------------			

			private function buttonInserir_clickHandler( event: MouseEvent): void 
			{
				var vitrineLvComponenteCadastro: VitrineLvComponenteCadastro = new VitrineLvComponenteCadastro();
				vitrineLvComponenteCadastro.vitrineLv = new VitrineLv(); 
				vitrineLvComponenteCadastro.addEventListener("VitrineLvIncluidoEvent", atualizarListaVitrineLvPorInclusaoResultHandler);
				UPCPopUpManager.instance.addPopUp(vitrineLvComponenteCadastro, this, true);
				UPCPopUpManager.instance.centerWindow(vitrineLvComponenteCadastro);
			}
			
			protected function buttonFechar_clickHandler(event:MouseEvent):void
			{
				var vitrineLvSelecionado: VitrineLv = datagridListaVitrineLv.selectedItem as VitrineLv;
				this.dispatchEvent(new ResultEvent("VitrineLvSelecionadoEvent",false, true, vitrineLvSelecionado, null, null));
				UPCPopUpManager.instance.removePopUp(this);
			}
			
			protected function datagridListaVitrineLv_doubleClickHandler(event:MouseEvent):void
			{
				vitrineLvComponenteDetalhe = new VitrineLvComponenteDetalhe();
				vitrineLvComponenteDetalhe.vitrineLv = datagridListaVitrineLv.selectedItem as VitrineLv;
				vitrineLvComponenteDetalhe.addEventListener("VitrineLvExcluidoEvent", atualizarListaVitrineLvPorExclusaoResultHandler);
				vitrineLvComponenteDetalhe.addEventListener("VitrineLvAtualizadoEvent", atualizarListaVitrineLvPorAtualizacaoResultHandler);
				UPCPopUpManager.instance.addPopUp(vitrineLvComponenteDetalhe, this, true);
				UPCPopUpManager.instance.centerWindow(vitrineLvComponenteDetalhe);
			}
			
			
			private function atualizarListaVitrineLvPorInclusaoResultHandler(e:Event):void
			{
				var remoteObjectVitrineLv: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("vitrineLvService", listarResultHandler);	
				remoteObjectVitrineLv.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, lastPage, montarObjetoFiltro()); 
			}
			
			private function atualizarListaVitrineLvPorAtualizacaoResultHandler(e:Event):void
			{
				var remoteObjectVitrineLv: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("vitrineLvService", listarResultHandler);	
				remoteObjectVitrineLv.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, pageNumber, montarObjetoFiltro()); 
				
			}
			
			
			private function atualizarListaVitrineLvPorExclusaoResultHandler(e:Event):void
			{
				var remoteObjectVitrineLv: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("vitrineLvService", listarResultHandler);	
				remoteObjectVitrineLv.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, pageNumber, montarObjetoFiltro()); 
			}
			
			
			
			
		
// -------------FUNCOES DE NAVEGACAO -------------------------------------------------------			
			protected function linkButtonProximaPagina_clickHandler(event:MouseEvent):void
			{
				var remoteObjectVitrineLv: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("vitrineLvService", listarResultHandler);	

				if (pageNumber < lastPage)
				{
					remoteObjectVitrineLv.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, (pageNumber + 1), montarObjetoFiltro());
				}
				else
				{
					remoteObjectVitrineLv.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, lastPage, montarObjetoFiltro());
				}				
			}
			
			protected function linkButtonAnteriorPagina_clickHandler(event:MouseEvent):void
			{
				var remoteObjectVitrineLv: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("vitrineLvService", listarResultHandler);	
				
				if (pageNumber > 1)
				{
					remoteObjectVitrineLv.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, (pageNumber - 1) , montarObjetoFiltro());
				}
				else
				{
					remoteObjectVitrineLv.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, 1 , montarObjetoFiltro());
				}
			}
			
			protected function linkButtonPrimeiraPagina_clickHandler(event:MouseEvent):void
			{
				var remoteObjectVitrineLv: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("vitrineLvService", listarResultHandler);	
				remoteObjectVitrineLv.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, 1 , montarObjetoFiltro()); 
			}
			
			protected function linkButtonUltimaPagina_clickHandler(event:MouseEvent):void
			{
				var remoteObjectVitrineLv: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("vitrineLvService", listarResultHandler);	
				remoteObjectVitrineLv.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, lastPage , montarObjetoFiltro()); 
			}
			
			protected function buttonPesquisarMarca_clickHandler(event:MouseEvent):void
			{
				var marcaComponentePesquisa:MarcaComponentePesquisa = new MarcaComponentePesquisa();
				marcaComponentePesquisa.addEventListener("MarcaSelecionadoEvent",  atualizarMarcaPorSelecaoResultHandler);
				UPCPopUpManager.instance.addPopUp(marcaComponentePesquisa, this, true);
				UPCPopUpManager.instance.centerWindow(marcaComponentePesquisa);
			}
			
			private function atualizarMarcaPorSelecaoResultHandler(event:ResultEvent):void
			{
				this.ignAutoCompleteMarca.itemSelecionado = event.result as Marca;
			}
			
		]]>
	</fx:Script>
	
	<fx:Declarations>
		<!-- Place non-visual elements (e.g., services, value objects) here -->
		<s:ArrayCollection id="listaOpcaoAtivo">
			<fx:Object codigo="" valor=""/>
			<fx:Object codigo="0" valor="Inativo"/>
			<fx:Object codigo="1" valor="Ativo"/>
		</s:ArrayCollection>
		<s:ArrayCollection id="listaOpcaoPaginacao">
			<fx:Object codigo="" valor=""/>
			<fx:Object codigo="0" valor="Sim"/>
			<fx:Object codigo="1" valor="Não"/>
		</s:ArrayCollection>
		<s:ArrayCollection id="listaOpcaoRandomizar">
			<fx:Object codigo="" valor=""/>
			<fx:Object codigo="0" valor="Sim"/>
			<fx:Object codigo="1" valor="Não"/>
		</s:ArrayCollection>
		<s:ArrayCollection id="listaOpcaoTipoExibicao">
			<fx:Object codigo="" valor=""/>
			<fx:Object codigo="0" valor="Vitrine"/>
			<fx:Object codigo="1" valor="Vitrine Home"/>
			<fx:Object codigo="2" valor="HotSite"/>
		</s:ArrayCollection>
		<s:ArrayCollection id="listaOpcaoSimNao">
			<fx:Object codigo="" valor=""/>
			<fx:Object codigo="S" valor="Sim"/>
			<fx:Object codigo="N" valor="Nao"/>
		</s:ArrayCollection>
			
	</fx:Declarations>
	
	<mx:Grid styleName="grid" verticalScrollPolicy="auto" horizontalScrollPolicy="auto" maxHeight="600" maxWidth="1024">
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>	
		<mx:GridRow>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Nome Vitrine:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoNomePesquisa" styleName="labelValidacao" text="{ignTextInputNomePesquisa.errorString}"/>
					<visual:IgnTextInput id="ignTextInputNomePesquisa" obrigatorio="false" listaValidadorForm="{this.listaValidadorForm}"/>
				</s:VGroup>
			</mx:GridItem>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Marca:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoMarca" styleName="labelValidacao" text="{ignAutoCompleteMarca.errorString}"/>
					<s:HGroup>
						<autoComplete:IgnAutoComplete idKeyName="id" palavraChave="descricao" id="ignAutoCompleteMarca" enviarArgumentos="true" destino="marcaService" funcaoChamada="listarPorObjetoFiltro" lenStartConsulta="3" nomeClasseObjetoFiltro="br.com.desenv.nepalign.vo.Marca" tabEnabled="true" width="200"/>
						<s:Button id="buttonPesquisarMarca" width="30" label="..." click="buttonPesquisarMarca_clickHandler(event)"/>
					</s:HGroup>
				</s:VGroup>
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Data Início de Exibição:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoDataInicioPesquisa" styleName="labelValidacao" text="{ignTextInputDateDataInicioPesquisa.errorString}"/>
					<visual:IgnTextInputDateTime id="ignTextInputDateDataInicioPesquisa" obrigatorio="false" listaValidadorForm="{this.listaValidadorForm}"/>
				</s:VGroup>
			</mx:GridItem>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Data Final de Exibição:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoDataFinalPesquisa" styleName="labelValidacao" text="{ignTextInputDateDataFinalPesquisa.errorString}"/>
					<visual:IgnTextInputDateTime id="ignTextInputDateDataFinalPesquisa" obrigatorio="false" listaValidadorForm="{this.listaValidadorForm}"/>
				</s:VGroup>
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Ativo:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoAtivoPesquisa" styleName="labelValidacao" text="{ignComboBoxFixoAtivoPesquisa.errorString}"/>
					<visual:IgnComboBoxFixo id="ignComboBoxFixoAtivoPesquisa" obrigatorio="false" dataProvider="{listaOpcaoAtivo}"  listaValidadorForm="{this.listaValidadorForm}"/> 
				</s:VGroup>
			</mx:GridItem>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Tipo Exibição:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoTipoExibicaoPesquisa" styleName="labelValidacao" text="{ignComboBoxFixoTipoExibicaoPesquisa.errorString}"/>
					<visual:IgnComboBoxFixo id="ignComboBoxFixoTipoExibicaoPesquisa" obrigatorio="false" dataProvider="{listaOpcaoTipoExibicao}"  listaValidadorForm="{this.listaValidadorForm}"/> 
				</s:VGroup>
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
		</mx:GridRow>
		<mx:GridRow>
 			<mx:GridItem colSpan="2">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>		
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="right">
				<mx:Button id="buttonFiltrar" label="Filtrar" click="buttonFiltrarClickHandler(event)"/>
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem colSpan="4">
				<s:Spacer/>	
			</mx:GridItem>
		</mx:GridRow>		
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				
				
				<mx:LinkButton id="linkButtonPrimeiraPagina" label="&lt;&lt;" click="linkButtonPrimeiraPagina_clickHandler(event)"/>
				<mx:LinkButton id="linkButtonAnteriorPagina" label="&lt;" click="linkButtonAnteriorPagina_clickHandler(event)"/>
				<mx:Label id="labelPaginaAtual" text=""/>
				<mx:LinkButton id="linkButtonProximaPagina" label="&gt;" click="linkButtonProximaPagina_clickHandler(event)"/>
				<mx:LinkButton id="linkButtonUltimaPagina" label="&gt;&gt;" click="linkButtonUltimaPagina_clickHandler(event)"/>				
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<mx:DataGrid id="datagridListaVitrineLv" maxWidth="720" verticalScrollPolicy="on" horizontalScrollPolicy="on" dataProvider="{listaVitrineLv}" doubleClick="datagridListaVitrineLv_doubleClickHandler(event)" doubleClickEnabled="true">
					<mx:columns>
						<mx:DataGridColumn visible="false" dataField="id"/>
						<mx:DataGridColumn dataField="nome" headerText="Nome Vitrine" resizable="true" width="230"/>
						<mx:DataGridColumn dataField="descricao" headerText="Descrição" resizable="true" width="210"/>
						<mx:DataGridColumn dataField="imagem" headerText="Nome Imagem" resizable="true" width="185"/>
						<mx:DataGridColumn dataField="dataInicio" headerText="Data Início de Exibição" resizable="true" labelFunction="DsvObjectUtil.formatDate" width="135"/>
						<mx:DataGridColumn dataField="dataFinal" headerText="Data Final de Exibição" resizable="true" labelFunction="DsvObjectUtil.formatDate" width="135"/>
						<mx:DataGridColumn dataField="ativoDescricaoCompleta" headerText="Ativo" resizable="true"/>
						<mx:DataGridColumn dataField="situacaoEnvioLv.descricao" headerText="Situação Envio LV" resizable="true"/>
<!--
						<mx:DataGridColumn dataField="numeroColunas" headerText="Numero de Colunas" resizable="true"/>
						<mx:DataGridColumn dataField="paginacaoDescricaoCompleta" headerText="Paginação" resizable="true"/>
						<mx:DataGridColumn dataField="randomizarDescricaoCompleta" headerText="Randomizar" resizable="true"/>
						<mx:DataGridColumn dataField="htmlCustomizado" headerText="HTML Customizado" resizable="true"/>
						<mx:DataGridColumn dataField="orderExibicao" headerText="Ordem de Exibição" resizable="true"/>
						<mx:DataGridColumn dataField="tipoExibicaoDescricaoCompleta" headerText="Tipo Exibição" resizable="true"/>
						<mx:DataGridColumn dataField="marca.descricao" headerText="Marca" resizable="true"/>
-->
					</mx:columns>
				</mx:DataGrid>
			</mx:GridItem>
		</mx:GridRow>	
		<mx:GridRow>
			
			<mx:GridItem colSpan="2" horizontalAlign="left">
				<mx:Label id="labelTotalRegistro" text=""/>
			</mx:GridItem>
			<mx:GridItem colSpan="2" horizontalAlign="right">
				<mx:Button id="buttonInserir" label="Novo" click="buttonInserir_clickHandler(event)"/>
				<mx:Button id="buttonFechar" label="Fechar" click="buttonFechar_clickHandler(event)"/>
			</mx:GridItem>	
		</mx:GridRow>
				
	</mx:Grid>
</s:TitleWindow>
